//---------------------------------------------------------------------------
#ifndef SharedCodeH
#define SharedCodeH

#include <Registry.hpp>

#include <vector>
#include <map>
#include <memory>

#include <winsock.h>
#include "ws-util.h"

using namespace std;

//---------------------------------------------------------------------------
void ShowSimpleMsg(AnsiString asMsg);
bool IsValidSymbol(AnsiString asSymbol, int iSymbolType);

Variant ReadFromRegistry(HKEY hKeyType, AnsiString sKeyName,
                         AnsiString sName, int vType,
                         bool bCheckCurrentUserFirst = false,
                         AnsiString sPCName = "");

TLogFont *ReadFontFromRegistry(HKEY hKeyType, AnsiString sKeyName, AnsiString sName,
                               bool bCheckCurrentUserFirst= false, AnsiString sPCName = "");

bool WriteToRegistry(HKEY hKeyType, String sKeyName, AnsiString sName,
                     Variant vData, AnsiString sPCName = "");
bool WriteFontToRegistry(HKEY hKeyType, String sKeyName, AnsiString sName,
                         TLogFont *pFont, AnsiString sPCName = "");

TStringList * ReadKeysFromRegistry(HKEY hKeyType, AnsiString sKeyName,
                                   bool bCheckCurrentUserFirst = false,
                                   AnsiString sPCName = "");

TStringList * ReadKeyValueNamesFromRegistry(HKEY hKeyType, AnsiString sKeyName,
                                   bool bCheckCurrentUserFirst = false,
                                   AnsiString sPCName = "");

bool DeleteKeyFromRegistry(HKEY hKeyType, AnsiString sKeyName, bool bCheckCurrentUserFirst = false,
                           AnsiString sPCName = "");

bool DeleteFromRegistry(HKEY hKeyType, AnsiString sKeyName, AnsiString sName,
                        bool bCheckCurrentUserFirst = false, AnsiString sPCName = "");

String __fastcall VersionInfo(const String &sQuery,AnsiString asFile="");

int StartProcess(AnsiString sAppName, WORD wShowWindow = SW_SHOW,
                 bool bWaitUntilDone = false, bool bReturnExitCode = false,
                 bool bReturnProcessID = false);

std::vector<AnsiString> GetDelimitedValues(AnsiString asData,AnsiString asDelimiter=",");

bool __fastcall StartNewBrowser(AnsiString asURL, AnsiString asLocalHTMLFile,int iShowCmd=SW_HIDE);
AnsiString __fastcall GetApplicationName(long &dwFlagReturned, AnsiString asHTMLFile);

bool __fastcall CreateNewFile(AnsiString asFile);
bool __fastcall RemoveFile(AnsiString asFile);

bool __fastcall CanConnectToHost(AnsiString asHostName, unsigned short portnum,
                                 AnsiString &asErrMsg);

int __fastcall ConnectToHost(char *myname, unsigned short portnum, int &iSocketErr, int iSocketType=SOCK_STREAM);

bool __fastcall FormExists(AnsiString asName);
TForm * __fastcall FindForm(AnsiString asName);

AnsiString __fastcall GetCommaTextFromMap(std::map<AnsiString,bool> &mapList, bool bQuotedTextItems=false);
AnsiString __fastcall GetCommaTextFromVector(std::vector<int> &vctList, bool bQuotedTextItems=false);

std::string StripCRLF(std::string sIn);
void StripSpaces(AnsiString &sIn);

void __fastcall WriteTextToDC(HWND WinHandle, AnsiString asText, int X=1, int Y=1);

bool __fastcall LaunchInDefaultViewer(HWND hHandle, AnsiString asFile);

void __fastcall LogDebugMsg(AnsiString asLOGFILE,AnsiString asMsg, bool bCreateIfMissing=false);

std::vector<AnsiString> GetLocalIPAddressListAndHostname(AnsiString *asHostname=NULL, AnsiString *asIPList=NULL);

#endif//---------------------------------------------------------------------------

