//---------------------------------------------------------------------------
#include <winsock2.h>
#include <vcl.h>
#pragma hdrstop

#include "formMain.h"

#include "rijndael_alg_fst.h"
#include "SharedCode.h"

#include <fstream>

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TfrmMain *frmMain;

//---------------------------------------------------------------------------
__fastcall TfrmMain::TfrmMain(TComponent* Owner)
        : TForm(Owner)
{
  WORD wVersionRequested = MAKEWORD(1, 1);

  // This section for windows sockets
  lpwsaData_m.reset(new WSADATA);
  int nResult = WSAStartup(wVersionRequested, lpwsaData_m.get());
  if(nResult != 0)
  {
    sbtnConnect->Enabled = false;
    memoLog->Lines->Add("Problem Initializing Winsock!");
  }
  else if(LOBYTE(lpwsaData_m->wVersion) != 1 || HIBYTE(lpwsaData_m->wVersion) != 1)
  {
    sbtnConnect->Enabled = false;
    memoLog->Lines->Add("Problem with Winsock Version: " + IntToStr(LOBYTE(lpwsaData_m->wVersion)) + "." + IntToStr(HIBYTE(lpwsaData_m->wVersion)));
  }

  iSocket_m = INVALID_SOCKET;

  cboServer->Items->Clear();
  TStringList *sltList = ReadKeysFromRegistry(HKEY_CURRENT_USER, "SOFTWARE\\VSOFT\\SOCKETSRVMANIP\\SERVERLIST");
  for(int i = 0; i < sltList->Count; i++)
  {
    AnsiString asServer = sltList->Strings[i];
    if(asServer != "")
    {
      cboServer->Items->Add(asServer);
    }
  }
  delete sltList;
  sltList = NULL;

  if(ReadFromRegistry(HKEY_CURRENT_USER, "SOFTWARE\\VSOFT\\SOCKETSRVMANIP", "LastServer" , varString).IsNull() == false)
  {
    cboServer->Text = ReadFromRegistry(HKEY_CURRENT_USER, "SOFTWARE\\VSOFT\\SOCKETSRVMANIP", "LastServer" , varString);
  }

  cboServerPort->Items->Clear();
  sltList = ReadKeysFromRegistry(HKEY_CURRENT_USER, "SOFTWARE\\VSOFT\\SOCKETSRVMANIP\\SERVERPORTS");
  for(int i = 0; i < sltList->Count; i++)
  {
    AnsiString asPort = sltList->Strings[i];
    if(asPort != "")
    {
      cboServerPort->Items->Add(asPort);
    }
  }
  delete sltList;
  sltList = NULL;

  if(ReadFromRegistry(HKEY_CURRENT_USER, "SOFTWARE\\VSOFT\\SOCKETSRVMANIP", "LastServerPort" , varString).IsNull() == false)
  {
    cboServerPort->Text = ReadFromRegistry(HKEY_CURRENT_USER, "SOFTWARE\\VSOFT\\SOCKETSRVMANIP", "LastServerPort" , varString);
  }

}

//---------------------------------------------------------------------------
__fastcall TfrmMain::~TfrmMain()
{
  if(iSocket_m > 0)
  {
    if(pThreadRecv_m.get() && pThreadRecv_m->IsRunning)
    {
      pThreadRecv_m->Terminate();
      Application->ProcessMessages();
      Sleep(500);
    }

    closesocket(iSocket_m);
  }

  while(pThreadRecv_m.get() && pThreadRecv_m->IsRunning)
  {
    pThreadRecv_m->Terminate();
    Sleep(500);
    Application->ProcessMessages();
  }

  WSACleanup();
}

//---------------------------------------------------------------------------
void __fastcall TfrmMain::HandleRecv(char *pBuf, int iBytes)
{
  //unsigned int iNewBytes = iBytes;
  //char *pHexBuf = EncryptedBufferToHexText((const char *)pBuf,iNewBytes);
  if(iBytes <= 0)
  {
    tmrSend->Enabled = false;
    sbtnSend->Enabled = false;
    sbtnSendHexToBin->Enabled = false;
    sbtnPauseRecv->Enabled = false;

    if(iBytes < 0)
    {
      const char *pError = WSAGetLastErrorMessage("recv()");
      AnsiString asMsg = "Internal error: " + (AnsiString)pError;
      memoLog->Lines->Add(asMsg);
    }
    else
    {
      memoLog->Lines->Add("Lost connection to host!");
    }
  }
  else
  {
    lblRecvCount->Caption = StrToInt(lblRecvCount->Caption)+1;
    lblRecvBytes->Caption = StrToInt(lblRecvBytes->Caption)+iBytes;

    //AnsiString asMsg = (pBuf && pBuf[0] ? pBuf : "");
    unsigned int iBufLen = iBytes;
    char *pHexData = EncryptedBufferToHexText(pBuf,iBufLen);
    memoRecv->Text = memoRecv->Text + (AnsiString)pHexData;

    delete [] pHexData;
    pHexData = NULL;

    AnsiString asMsg = "Recv: " + IntToStr(iBytes) + " Bytes OK!";
    memoLog->Lines->Add(asMsg);
  }
}

//---------------------------------------------------------------------------
void __fastcall TfrmMain::sbtnConnectClick(TObject *Sender)
{
  if(cboServer->Text != "" && cboServerPort->Text != "")
  {
    bool bRet = WriteToRegistry(HKEY_CURRENT_USER, "SOFTWARE\\VSOFT\\SOCKETSRVMANIP\\SERVERLIST\\" + cboServer->Text, NULL, NULL);
    bRet = WriteToRegistry(HKEY_CURRENT_USER, "SOFTWARE\\VSOFT\\SOCKETSRVMANIP\\SERVERPORTS\\" + cboServerPort->Text, NULL, NULL);
    WriteToRegistry(HKEY_CURRENT_USER, "SOFTWARE\\VSOFT\\SOCKETSRVMANIP", "LastServer" , cboServer->Text);
    WriteToRegistry(HKEY_CURRENT_USER, "SOFTWARE\\VSOFT\\SOCKETSRVMANIP", "LastServerPort" , cboServerPort->Text);

    if(iSocket_m > 0)
    {
      if(pThreadRecv_m.get() && pThreadRecv_m->IsRunning)
      {
        pThreadRecv_m->Terminate();
        Application->ProcessMessages();
        Sleep(500);
      }

      closesocket(iSocket_m);
    }

    while(pThreadRecv_m.get() && pThreadRecv_m->IsRunning)
    {
      pThreadRecv_m->Terminate();
      Sleep(500);
      Application->ProcessMessages();
    }


    char szHost[255]="";
    strcpy(szHost,cboServer->Text.c_str());

    int iPort = cboServerPort->Text.ToIntDef(0);

    int iSocketErr = -1;

    iSocket_m = ConnectToHost(szHost, iPort);
    if(iSocket_m > 0)
    {
      memoRecv->Text = "";
      memoLog->Text = "";

      pThreadRecv_m.reset(new thrSocketRecv(true));
      pThreadRecv_m->Setup(iSocket_m,HandleRecv);
      pThreadRecv_m->Resume();

      sbtnSend->Enabled = true;
      sbtnSendHexToBin->Enabled = true;
      sbtnPauseRecv->Enabled = true;

      memoLog->Lines->Add("Connected successfully!");
    }
    else
    {
      const char *pError = WSAGetLastErrorMessage("ConnectToHost()",iSocket_m);
      AnsiString asMsg = "Internal error: " + (AnsiString)pError;
      memoLog->Lines->Add(asMsg);
    }
  }
}

//---------------------------------------------------------------------------
void __fastcall TfrmMain::sbtnSendClick(TObject *Sender)
{
  try
  {
    tmrSend->Enabled = false;
    iNextSendType_m = 0;

    int iLen = (memoSend->SelLength > 0 ? memoSend->SelText.Length() : memoSend->Text.Length());

    char *pBuf = new char[iLen+1];
    memset(pBuf,0,iLen+1);

    memcpy(pBuf,(memoSend->SelLength > 0 ? memoSend->SelText.c_str() : memoSend->Text.c_str()),iLen);
    int iBytes = send(iSocket_m,pBuf,iLen,0);
    if(iBytes > 0)
    {
      AnsiString asMsg = "Sent: " + IntToStr(iBytes) + " Bytes OK!";
      memoLog->Lines->Add(asMsg);

      if(edtSendFreq->Text != "")
      {
        tmrSend->Enabled = true;
      }
    }
    else
    {
      const char *pError = WSAGetLastErrorMessage("send()");
      AnsiString asMsg = "Internal error: " + (AnsiString)pError;
      memoLog->Lines->Add(asMsg);

      sbtnSend->Enabled = false;
      sbtnSendHexToBin->Enabled = false;
      sbtnPauseRecv->Enabled = false;
    }
  }
  __finally
  {

  }
}

//---------------------------------------------------------------------------
void __fastcall TfrmMain::sbtnPauseRecvClick(TObject *Sender)
{
  sbtnPauseRecv->Tag = !sbtnPauseRecv->Tag;
  if(sbtnPauseRecv->Tag)
  {
    sbtnPauseRecv->Caption = "Resume Recv";
  }
  else
  {
    sbtnPauseRecv->Caption = "Pause Recv";
  }

  pThreadRecv_m->PauseStatus = sbtnPauseRecv->Tag;
}

//---------------------------------------------------------------------------
void __fastcall TfrmMain::sbtnSendHexToBinClick(TObject *Sender)
{
  try
  {
    tmrSend->Enabled = false;
    iNextSendType_m = 1;

    unsigned int iBufLen = (memoSend->SelLength > 0 ? memoSend->SelText.Length() : memoSend->Text.Length());
    char *pBinData = HexTextToEncryptedBuffer((memoSend->SelLength > 0 ? memoSend->SelText.c_str() : memoSend->Text.c_str()),iBufLen);

    try
    {
      int iLen = iBufLen;
      char *pBuf = new char[iLen+1];
      memset(pBuf,0,iLen+1);
      memcpy(pBuf,pBinData,iLen);
      int iBytes = send(iSocket_m,pBuf,iLen,0);
      if(iBytes > 0)
      {
        AnsiString asMsg = "Sent: " + IntToStr(iBytes) + " Bytes OK!";
        memoLog->Lines->Add(asMsg);

        if(edtSendFreq->Text != "")
        {
          tmrSend->Enabled = true;
        }
      }
      else
      {
        const char *pError = WSAGetLastErrorMessage("send()");
        AnsiString asMsg = "Internal error: " + (AnsiString)pError;
        memoLog->Lines->Add(asMsg);

        sbtnSend->Enabled = false;
        sbtnSendHexToBin->Enabled = false;
        sbtnPauseRecv->Enabled = false;
      }
    }
    __finally
    {
      delete [] pBinData;
      pBinData = NULL;
    }
  }
  __finally
  {

  }
}

//---------------------------------------------------------------------------
void __fastcall TfrmMain::sbtnRecvHexToBinClick(TObject *Sender)
{
  unsigned int iBufLen = (memoRecv->SelLength > 0 ? memoRecv->SelText.Length() : memoRecv->Text.Length());

  AnsiString asHexData = (memoRecv->SelLength > 0 ? memoRecv->SelText.c_str() : memoRecv->Text.c_str());
  StripSpaces(asHexData);
  iBufLen = asHexData.Length();

  char *pBinData = HexTextToEncryptedBuffer(asHexData.c_str(),iBufLen);

  if(memoRecv->SelLength > 0)
  {
    memoRecv->SelText = pBinData;
  }
  else
  {
    memoRecv->Text = pBinData;
  }

  delete [] pBinData;
  pBinData = NULL;
}

//---------------------------------------------------------------------------
void __fastcall TfrmMain::sbrtnClearRecvClick(TObject *Sender)
{
  memoRecv->Lines->Clear();
}

//---------------------------------------------------------------------------
void __fastcall TfrmMain::sbtnSaveHexToBinFileClick(TObject *Sender)
{
  unsigned int iBufLen = (memoRecv->SelLength > 0 ? memoRecv->SelText.Length() : memoRecv->Text.Length());
  if(iBufLen <= 0)
  {
    MessageBox(Handle,"No data to save, size is 0","Warning",MB_OK | MB_TASKMODAL);
    return;
  }

  if(dlgSaveFile->Execute())
  {
    ofstream oBinFile(dlgSaveFile->FileName.c_str());
    if(oBinFile.is_open())
    {
      AnsiString asHexData = (memoRecv->SelLength > 0 ? memoRecv->SelText : memoRecv->Text);
      StripSpaces(asHexData);
      iBufLen = asHexData.Length();

      char *pBinData = HexTextToEncryptedBuffer(asHexData.c_str(),iBufLen);

      oBinFile.write(pBinData,iBufLen);
      oBinFile.close();

      delete [] pBinData;
      pBinData = NULL;
    }
  }
}

//---------------------------------------------------------------------------
void __fastcall TfrmMain::sbtnLoadBinToHexClick(TObject *Sender)
{
  if(dlgOpenFile->Execute())
  {
    ifstream iBinFile(dlgOpenFile->FileName.c_str());
    if(iBinFile.is_open())
    {
      iBinFile.seekg(0L,ios::end);
      unsigned int uiFileSize = static_cast<unsigned int>(iBinFile.tellg());   // << this is
      iBinFile.seekg(0L);

      char *pBuf = new char[uiFileSize+1];
      memset(pBuf,0,uiFileSize+1);

      iBinFile.read(pBuf,uiFileSize);
      iBinFile.close();

      bool bSkip = false;
      if(chkLoadAndConvertHex->Checked == false)
      {
        if(MessageBox(Handle,"Load binary file without translating to HEX?","Question",MB_YESNO | MB_TASKMODAL) == IDNO)
        {
          bSkip = true;
        }
      }

      if(bSkip == false)
      {
        char *pHexData = NULL;
        if(chkLoadAndConvertHex->Checked)
        {
          unsigned int iBufLen = uiFileSize;
          pHexData = EncryptedBufferToHexText(pBuf,iBufLen);
          memoSend->Text = pHexData;
        }
        else
        {
          memoSend->Text = pBuf;
        }

        delete [] pHexData;
        pHexData = NULL;
      }

      delete [] pBuf;
      pBuf = NULL;
    }
  }
}

//---------------------------------------------------------------------------
void __fastcall TfrmMain::edtSendFreqChange(TObject *Sender)
{
  int iFreq = edtSendFreq->Text.ToIntDef(0);

  if(iFreq > 0)
  {
    tmrSend->Interval = iFreq;
  }
  else
  {
    tmrSend->Enabled = false;
  }
}

//---------------------------------------------------------------------------
void __fastcall TfrmMain::tmrSendTimer(TObject *Sender)
{
  switch(iNextSendType_m)
  {
    case 0:
      sbtnSendClick(Sender);
      break;

    case 1:
      sbtnSendHexToBinClick(Sender);
      break;
  }
}

//---------------------------------------------------------------------------
void __fastcall TfrmMain::sbtnHexToolClick(TObject *Sender)
{
  if(fmHexTool_m.get() == NULL)
  {
    fmHexTool_m.reset(new TfrmHexConversionTool(this));
    fmHexTool_m->Show();
  }
  else
  {
    if(fmHexTool_m->WindowState == wsMinimized)
    {
      fmHexTool_m->WindowState = wsNormal;
    }

    fmHexTool_m->BringToFront();
  }
}

//---------------------------------------------------------------------------
void __fastcall TfrmMain::WMCloseHexTool(TMessage &msg)
{
  if(fmHexTool_m.get() != NULL)
  {
    fmHexTool_m.reset(NULL);
  }

  msg.Result = true;
}

//---------------------------------------------------------------------------

