//---------------------------------------------------------------------------
#ifndef formMainH
#define formMainH

//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>

#include "classSocketRecv.h"
#include <Dialogs.hpp>
#include <ExtDlgs.hpp>

#include "frmHexTool.h"

#include <memory>

using namespace std;

//---------------------------------------------------------------------------
class TfrmMain : public TForm
{
__published:	// IDE-managed Components
        TLabel *Label1;
        TLabel *Label2;
        TMemo *memoSend;
        TMemo *memoRecv;
        TSpeedButton *sbtnConnect;
        TMemo *memoLog;
        TPanel *panSend;
        TSpeedButton *sbtnSend;
        TLabel *Label4;
        TPanel *panRecv;
        TSpeedButton *sbtnPauseRecv;
        TPanel *panRecvTop;
        TLabel *Label3;
        TLabel *Label5;
        TLabel *lblRecvCount;
  TSpeedButton *sbtnRecvHexToBin;
  TSpeedButton *sbtnSendHexToBin;
  TLabel *Label6;
  TLabel *lblRecvBytes;
  TSpeedButton *sbrtnClearRecv;
  TSpeedButton *sbtnSaveHexToBinFile;
  TComboBox *cboServer;
  TComboBox *cboServerPort;
  TSaveDialog *dlgSaveFile;
        TSpeedButton *sbtnLoadBinToHex;
        TOpenDialog *dlgOpenFile;
        TCheckBox *chkLoadAndConvertHex;
        TTimer *tmrSend;
        TEdit *edtSendFreq;
        TLabel *Label7;
        TSpeedButton *sbtnHexTool;
        void __fastcall sbtnConnectClick(TObject *Sender);
        void __fastcall sbtnSendClick(TObject *Sender);
        void __fastcall sbtnPauseRecvClick(TObject *Sender);
  void __fastcall sbtnSendHexToBinClick(TObject *Sender);
  void __fastcall sbtnRecvHexToBinClick(TObject *Sender);
  void __fastcall sbrtnClearRecvClick(TObject *Sender);
  void __fastcall sbtnSaveHexToBinFileClick(TObject *Sender);
        void __fastcall sbtnLoadBinToHexClick(TObject *Sender);
        void __fastcall edtSendFreqChange(TObject *Sender);
        void __fastcall tmrSendTimer(TObject *Sender);
        void __fastcall sbtnHexToolClick(TObject *Sender);
private:	// User declarations

  std::auto_ptr<WSADATA> lpwsaData_m;
  int iSocket_m;

  std::auto_ptr<thrSocketRecv> pThreadRecv_m;

  int iNextSendType_m;

  std::auto_ptr<TfrmHexConversionTool> fmHexTool_m;

  void __fastcall HandleRecv(char *pBuf, int iBytes);

  void __fastcall WMCloseHexTool(TMessage &msg);

public:		// User declarations

  __fastcall TfrmMain(TComponent* Owner);
  __fastcall ~TfrmMain();

// Windows Messages to Capture for processing
BEGIN_MESSAGE_MAP

  MESSAGE_HANDLER(CLOSE_HEX_TOOL,TMessage,WMCloseHexTool);

END_MESSAGE_MAP(TForm);
};
//---------------------------------------------------------------------------
extern PACKAGE TfrmMain *frmMain;
//---------------------------------------------------------------------------
#endif
