//---------------------------------------------------------------------------
#include <winsock2.h>
#include <vcl.h>
#pragma hdrstop

#include "frmHexTool.h"

#include "rijndael_alg_fst.h"
#include "SharedCode.h"
#include <stdio.h>
#include <time.h>

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TfrmHexConversionTool *frmHexConversionTool;

//---------------------------------------------------------------------------
__fastcall TfrmHexConversionTool::TfrmHexConversionTool(TComponent* Owner)
        : TForm(Owner)
{
  char szBuffer[100] = {"\0"};
  hConsole_m = NULL;

  // create console
  if (AllocConsole())
  {
    // now, a little footwork to get the handle to this window...
    // this is a GUID + process ID - since there can only be one console
    // per process this should be overkill...
    sprintf(szBuffer,"{9D35CC6F-8CBE-4C6C-8498-2B3E2F9F4824}%ld",GetCurrentProcessId());

    // set the title to a GUID plus the process ID
    SetConsoleTitle(szBuffer) ;

    // SetConsoleTitle seems to just post a msg (?) - so we may
    // encounter a delay before we can identify the window...
    time_t tStart = time(NULL);
    while(!hConsole_m && difftime(time(NULL),tStart <= 10))
    {
      hConsole_m = ::FindWindowEx(NULL, NULL, NULL, szBuffer);
    }

    ::SetParent(hConsole_m, panBinaryDisplay->Handle);

    WINDOWPLACEMENT wp;
    wp.length = sizeof wp;
    if (GetWindowPlacement(hConsole_m,&wp))
    {
      wp.showCmd = SW_SHOWMAXIMIZED;
      bool bRet = SetWindowPlacement(hConsole_m,&wp);
      int ii = 0;
    }

    HMENU hmenu = GetSystemMenu(hConsole_m, false);
    bool bRet = DeleteMenu(hmenu, SC_RESTORE , MF_BYCOMMAND);
    if(!bRet)
    {
      DWORD dwGLE = GetLastError();
      int ii = 0;
    }

    hmenu = GetSystemMenu(hConsole_m, false);
    bRet = DeleteMenu(hmenu, SC_MINIMIZE , MF_BYCOMMAND);
    if(!bRet)
    {
      DWORD dwGLE = GetLastError();
      int ii = 0;
    }

    hmenu = GetSystemMenu(hConsole_m, false);
    bRet = DeleteMenu(hmenu, SC_MAXIMIZE , MF_BYCOMMAND);
    if(!bRet)
    {
      DWORD dwGLE = GetLastError();
      int ii = 0;
    }

    hmenu = GetSystemMenu(hConsole_m, false);
    bRet = DeleteMenu(hmenu, SC_MOVE , MF_BYCOMMAND);
    if(!bRet)
    {
      DWORD dwGLE = GetLastError();
      int ii = 0;
    }

    hmenu = GetSystemMenu(hConsole_m, false);
    bRet = DeleteMenu(hmenu, SC_CLOSE , MF_BYCOMMAND);
    if(!bRet)
    {
      DWORD dwGLE = GetLastError();
      int ii = 0;
    }
  }
}

//---------------------------------------------------------------------------
__fastcall TfrmHexConversionTool::~TfrmHexConversionTool()
{
  FreeConsole();
}

//---------------------------------------------------------------------------
void __fastcall TfrmHexConversionTool::bbtnCloseClick(TObject *Sender)
{
  Close();
}

//---------------------------------------------------------------------------
void __fastcall TfrmHexConversionTool::bbtnToHexClick(TObject *Sender)
{
  unsigned int iBufLen = memoHex->Text.Length();

  char *pBuf = new char[iBufLen+1];
  memset(pBuf,0,iBufLen+1);
  memcpy(pBuf,memoHex->Text.c_str(),iBufLen);

  char *pHexData = EncryptedBufferToHexText(pBuf,iBufLen);
  memoHex->Text = pHexData;

  HANDLE StdOut = GetStdHandle(STD_OUTPUT_HANDLE);
  DWORD LenWrt = 0;
  WriteConsole(StdOut,pBuf,iBufLen,&LenWrt,NULL);

  delete [] pBuf;
  pBuf = NULL;

  delete [] pHexData;
  pHexData = NULL;
}

//---------------------------------------------------------------------------
void __fastcall TfrmHexConversionTool::bbtnFromHexClick(TObject *Sender)
{
  unsigned int iBufLen = memoHex->Text.Length();

  AnsiString asHexData = memoHex->Text;
  StripSpaces(asHexData);
  iBufLen = asHexData.Length();

  char *pBinData = HexTextToEncryptedBuffer(asHexData.c_str(),iBufLen);

  memoHex->Text = pBinData;

  HANDLE StdOut = GetStdHandle(STD_OUTPUT_HANDLE);
  DWORD LenWrt = 0;
  WriteConsole(StdOut,pBinData,iBufLen,&LenWrt,NULL);

  delete [] pBinData;
  pBinData = NULL;
}

//---------------------------------------------------------------------------
void __fastcall TfrmHexConversionTool::FormClose(TObject *Sender,
      TCloseAction &Action)
{
  WriteToRegistry(HKEY_CURRENT_USER, "Software\\VSOFT\\SOCKETSRVMANIP\\Windows\\" + this->ClassName(), "Left",this->Left);
  WriteToRegistry(HKEY_CURRENT_USER, "Software\\VSOFT\\SOCKETSRVMANIP\\Windows\\" + this->ClassName(), "Top",this->Top);

  PostMessage(Application->MainForm->Handle,CLOSE_HEX_TOOL,0,0);
}

//---------------------------------------------------------------------------
void __fastcall TfrmHexConversionTool::FormShow(TObject *Sender)
{
  if(ReadFromRegistry(HKEY_CURRENT_USER, "Software\\VSOFT\\SOCKETSRVMANIP\\Windows\\" + this->ClassName(), "Left",varInteger).IsNull() == false)
  {
    this->Left = ReadFromRegistry(HKEY_CURRENT_USER, "Software\\VSOFT\\SOCKETSRVMANIP\\Windows\\" + this->ClassName(), "Left",varInteger);
  }

  if(ReadFromRegistry(HKEY_CURRENT_USER, "Software\\VSOFT\\SOCKETSRVMANIP\\Windows\\" + this->ClassName(), "Top",varInteger).IsNull() == false)
  {
    this->Top = ReadFromRegistry(HKEY_CURRENT_USER, "Software\\VSOFT\\SOCKETSRVMANIP\\Windows\\" + this->ClassName(), "Top",varInteger);
  }
}

//---------------------------------------------------------------------------
void __fastcall TfrmHexConversionTool::panBinaryDisplayResize(
      TObject *Sender)
{
  WINDOWPLACEMENT wp;
  wp.length = sizeof wp;
  if (GetWindowPlacement(hConsole_m,&wp))
  {
    wp.showCmd = SW_SHOWNORMAL;
    bool bRet = SetWindowPlacement(hConsole_m,&wp);
    int ii = 0;
  }

  wp.length = sizeof wp;
  if (GetWindowPlacement(hConsole_m,&wp))
  {
    wp.showCmd = SW_SHOWMAXIMIZED;
    bool bRet = SetWindowPlacement(hConsole_m,&wp);
    int ii = 0;
  }

}

//---------------------------------------------------------------------------

